<template>
    <div>
        <app-dropdown v-if="!reposted">
            <template slot="trigger">
                <app-post-share-action-button :post="post" />
            </template>

            <app-dropdown-item @click.prevent="toggleSharePost">Share post</app-dropdown-item>
            <app-dropdown-item @click.prevent="$modal.show(AppQuotePostModal, { post })">Quote post</app-dropdown-item>
        </app-dropdown>
        <app-post-share-action-button v-else :post="post" @click.prevent="toggleSharePost" />
    </div>
</template>
<script>
import { mapGetters, mapActions } from 'vuex';
import AppQuotePostModal from '../../modals/AppQuotePostModal';

export default {
    props: {
        post: {
            required: true,
            type: Object
        }
    },

    data() {
        return {
            AppQuotePostModal
        }
    },

    computed: {
        ...mapGetters({
            reposts: 'reposts/reposts',   
        }),

        reposted() {
            return this.reposts.includes(this.post.id);
        }
    },

    methods: {
        ...mapActions({
            sharePost: 'reposts/sharePost',
            unsharePost: 'reposts/unsharePost'
        }),

        toggleSharePost() {
            if(this.reposted) {
                this.unsharePost(this.post);
                return;
            }
            this.sharePost(this.post);
        }
    }, 
}
</script>